{-# language CPP #-}
-- No documentation found for Chapter "Dependencies"
module Vulkan.Extensions.Dependencies  ( extensionDependencies
                                       , extensionCoreRequirement
                                       ) where

import Data.Word (Word32)
import Data.ByteString (ByteString)
import Vulkan.NamedType ((:::))
import Vulkan.Extensions.VK_AMD_display_native_hdr (pattern AMD_DISPLAY_NATIVE_HDR_EXTENSION_NAME)
import Vulkan.Extensions.VK_AMD_shader_core_properties2 (pattern AMD_SHADER_CORE_PROPERTIES_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_AMD_shader_core_properties (pattern AMD_SHADER_CORE_PROPERTIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_AMD_texture_gather_bias_lod (pattern AMD_TEXTURE_GATHER_BIAS_LOD_EXTENSION_NAME)
import Vulkan.Extensions.VK_ANDROID_external_memory_android_hardware_buffer (pattern ANDROID_EXTERNAL_MEMORY_ANDROID_HARDWARE_BUFFER_EXTENSION_NAME)
import Vulkan.Core10 (pattern API_VERSION_1_0)
import Vulkan.Extensions.VK_EXT_4444_formats (pattern EXT_4444_FORMATS_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_acquire_xlib_display (pattern EXT_ACQUIRE_XLIB_DISPLAY_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_astc_decode_mode (pattern EXT_ASTC_DECODE_MODE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_buffer_device_address (pattern EXT_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_color_write_enable (pattern EXT_COLOR_WRITE_ENABLE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_conservative_rasterization (pattern EXT_CONSERVATIVE_RASTERIZATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_debug_marker (pattern EXT_DEBUG_MARKER_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_debug_report (pattern EXT_DEBUG_REPORT_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_descriptor_indexing (pattern EXT_DESCRIPTOR_INDEXING_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_device_memory_report (pattern EXT_DEVICE_MEMORY_REPORT_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_directfb_surface (pattern EXT_DIRECTFB_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_direct_mode_display (pattern EXT_DIRECT_MODE_DISPLAY_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_discard_rectangles (pattern EXT_DISCARD_RECTANGLES_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_display_control (pattern EXT_DISPLAY_CONTROL_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_display_surface_counter (pattern EXT_DISPLAY_SURFACE_COUNTER_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_extended_dynamic_state2 (pattern EXT_EXTENDED_DYNAMIC_STATE_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_extended_dynamic_state (pattern EXT_EXTENDED_DYNAMIC_STATE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_external_memory_dma_buf (pattern EXT_EXTERNAL_MEMORY_DMA_BUF_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_external_memory_host (pattern EXT_EXTERNAL_MEMORY_HOST_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_fragment_density_map2 (pattern EXT_FRAGMENT_DENSITY_MAP_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_fragment_density_map (pattern EXT_FRAGMENT_DENSITY_MAP_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_fragment_shader_interlock (pattern EXT_FRAGMENT_SHADER_INTERLOCK_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_full_screen_exclusive (pattern EXT_FULL_SCREEN_EXCLUSIVE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_global_priority (pattern EXT_GLOBAL_PRIORITY_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_global_priority_query (pattern EXT_GLOBAL_PRIORITY_QUERY_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_hdr_metadata (pattern EXT_HDR_METADATA_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_headless_surface (pattern EXT_HEADLESS_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_host_query_reset (pattern EXT_HOST_QUERY_RESET_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_image_drm_format_modifier (pattern EXT_IMAGE_DRM_FORMAT_MODIFIER_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_image_robustness (pattern EXT_IMAGE_ROBUSTNESS_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_inline_uniform_block (pattern EXT_INLINE_UNIFORM_BLOCK_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_line_rasterization (pattern EXT_LINE_RASTERIZATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_memory_budget (pattern EXT_MEMORY_BUDGET_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_memory_priority (pattern EXT_MEMORY_PRIORITY_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_metal_surface (pattern EXT_METAL_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_pci_bus_info (pattern EXT_PCI_BUS_INFO_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_provoking_vertex (pattern EXT_PROVOKING_VERTEX_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_queue_family_foreign (pattern EXT_QUEUE_FAMILY_FOREIGN_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_sampler_filter_minmax (pattern EXT_SAMPLER_FILTER_MINMAX_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_sample_locations (pattern EXT_SAMPLE_LOCATIONS_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_scalar_block_layout (pattern EXT_SCALAR_BLOCK_LAYOUT_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_shader_atomic_float (pattern EXT_SHADER_ATOMIC_FLOAT_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_shader_demote_to_helper_invocation (pattern EXT_SHADER_DEMOTE_TO_HELPER_INVOCATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_shader_image_atomic_int64 (pattern EXT_SHADER_IMAGE_ATOMIC_INT64_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_subgroup_size_control (pattern EXT_SUBGROUP_SIZE_CONTROL_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_swapchain_colorspace (pattern EXT_SWAPCHAIN_COLOR_SPACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_texel_buffer_alignment (pattern EXT_TEXEL_BUFFER_ALIGNMENT_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_texture_compression_astc_hdr (pattern EXT_TEXTURE_COMPRESSION_ASTC_HDR_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_transform_feedback (pattern EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_vertex_attribute_divisor (pattern EXT_VERTEX_ATTRIBUTE_DIVISOR_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_vertex_input_dynamic_state (pattern EXT_VERTEX_INPUT_DYNAMIC_STATE_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_ycbcr_2plane_444_formats (pattern EXT_YCBCR_2PLANE_444_FORMATS_EXTENSION_NAME)
import Vulkan.Extensions.VK_EXT_ycbcr_image_arrays (pattern EXT_YCBCR_IMAGE_ARRAYS_EXTENSION_NAME)
import Vulkan.Extensions.VK_FUCHSIA_external_memory (pattern FUCHSIA_EXTERNAL_MEMORY_EXTENSION_NAME)
import Vulkan.Extensions.VK_FUCHSIA_external_semaphore (pattern FUCHSIA_EXTERNAL_SEMAPHORE_EXTENSION_NAME)
import Vulkan.Extensions.VK_FUCHSIA_imagepipe_surface (pattern FUCHSIA_IMAGEPIPE_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_GGP_frame_token (pattern GGP_FRAME_TOKEN_EXTENSION_NAME)
import Vulkan.Extensions.VK_GGP_stream_descriptor_surface (pattern GGP_STREAM_DESCRIPTOR_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_GOOGLE_display_timing (pattern GOOGLE_DISPLAY_TIMING_EXTENSION_NAME)
import Vulkan.Extensions.VK_INTEL_shader_integer_functions2 (pattern INTEL_SHADER_INTEGER_FUNCTIONS_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_16bit_storage (pattern KHR_16BIT_STORAGE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_8bit_storage (pattern KHR_8BIT_STORAGE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_acceleration_structure (pattern KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_android_surface (pattern KHR_ANDROID_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_bind_memory2 (pattern KHR_BIND_MEMORY_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_buffer_device_address (pattern KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_copy_commands2 (pattern KHR_COPY_COMMANDS_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_create_renderpass2 (pattern KHR_CREATE_RENDERPASS_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_dedicated_allocation (pattern KHR_DEDICATED_ALLOCATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_deferred_host_operations (pattern KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_depth_stencil_resolve (pattern KHR_DEPTH_STENCIL_RESOLVE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_device_group_creation (pattern KHR_DEVICE_GROUP_CREATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_device_group (pattern KHR_DEVICE_GROUP_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_display (pattern KHR_DISPLAY_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_display_swapchain (pattern KHR_DISPLAY_SWAPCHAIN_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_driver_properties (pattern KHR_DRIVER_PROPERTIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_fence_capabilities (pattern KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_fence (pattern KHR_EXTERNAL_FENCE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_fence_fd (pattern KHR_EXTERNAL_FENCE_FD_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_fence_win32 (pattern KHR_EXTERNAL_FENCE_WIN32_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_memory_capabilities (pattern KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_memory (pattern KHR_EXTERNAL_MEMORY_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_memory_fd (pattern KHR_EXTERNAL_MEMORY_FD_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_memory_win32 (pattern KHR_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_semaphore_capabilities (pattern KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_semaphore (pattern KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_semaphore_fd (pattern KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_external_semaphore_win32 (pattern KHR_EXTERNAL_SEMAPHORE_WIN32_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_fragment_shading_rate (pattern KHR_FRAGMENT_SHADING_RATE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_get_display_properties2 (pattern KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_get_memory_requirements2 (pattern KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_get_physical_device_properties2 (pattern KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_get_surface_capabilities2 (pattern KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_imageless_framebuffer (pattern KHR_IMAGELESS_FRAMEBUFFER_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_image_format_list (pattern KHR_IMAGE_FORMAT_LIST_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_incremental_present (pattern KHR_INCREMENTAL_PRESENT_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_maintenance1 (pattern KHR_MAINTENANCE1_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_maintenance2 (pattern KHR_MAINTENANCE2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_maintenance3 (pattern KHR_MAINTENANCE3_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_multiview (pattern KHR_MULTIVIEW_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_performance_query (pattern KHR_PERFORMANCE_QUERY_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_pipeline_executable_properties (pattern KHR_PIPELINE_EXECUTABLE_PROPERTIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_portability_subset (pattern KHR_PORTABILITY_SUBSET_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_push_descriptor (pattern KHR_PUSH_DESCRIPTOR_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_ray_query (pattern KHR_RAY_QUERY_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_ray_tracing_pipeline (pattern KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_sampler_ycbcr_conversion (pattern KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_separate_depth_stencil_layouts (pattern KHR_SEPARATE_DEPTH_STENCIL_LAYOUTS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_atomic_int64 (pattern KHR_SHADER_ATOMIC_INT64_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_clock (pattern KHR_SHADER_CLOCK_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_float16_int8 (pattern KHR_SHADER_FLOAT16_INT8_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_float_controls (pattern KHR_SHADER_FLOAT_CONTROLS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_subgroup_extended_types (pattern KHR_SHADER_SUBGROUP_EXTENDED_TYPES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_subgroup_uniform_control_flow (pattern KHR_SHADER_SUBGROUP_UNIFORM_CONTROL_FLOW_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shader_terminate_invocation (pattern KHR_SHADER_TERMINATE_INVOCATION_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_shared_presentable_image (pattern KHR_SHARED_PRESENTABLE_IMAGE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_spirv_1_4 (pattern KHR_SPIRV_1_4_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_storage_buffer_storage_class (pattern KHR_STORAGE_BUFFER_STORAGE_CLASS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_surface (pattern KHR_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_surface_protected_capabilities (pattern KHR_SURFACE_PROTECTED_CAPABILITIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_swapchain (pattern KHR_SWAPCHAIN_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_swapchain_mutable_format (pattern KHR_SWAPCHAIN_MUTABLE_FORMAT_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_synchronization2 (pattern KHR_SYNCHRONIZATION_2_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_timeline_semaphore (pattern KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_uniform_buffer_standard_layout (pattern KHR_UNIFORM_BUFFER_STANDARD_LAYOUT_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_variable_pointers (pattern KHR_VARIABLE_POINTERS_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_wayland_surface (pattern KHR_WAYLAND_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_win32_keyed_mutex (pattern KHR_WIN32_KEYED_MUTEX_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_win32_surface (pattern KHR_WIN32_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_workgroup_memory_explicit_layout (pattern KHR_WORKGROUP_MEMORY_EXPLICIT_LAYOUT_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_xcb_surface (pattern KHR_XCB_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_xlib_surface (pattern KHR_XLIB_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_KHR_zero_initialize_workgroup_memory (pattern KHR_ZERO_INITIALIZE_WORKGROUP_MEMORY_EXTENSION_NAME)
import Vulkan.Version (pattern MAKE_API_VERSION)
import Vulkan.Extensions.VK_MVK_ios_surface (pattern MVK_IOS_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_MVK_macos_surface (pattern MVK_MACOS_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NN_vi_surface (pattern NN_VI_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NVX_multiview_per_view_attributes (pattern NVX_MULTIVIEW_PER_VIEW_ATTRIBUTES_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_acquire_winrt_display (pattern NV_ACQUIRE_WINRT_DISPLAY_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_compute_shader_derivatives (pattern NV_COMPUTE_SHADER_DERIVATIVES_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_cooperative_matrix (pattern NV_COOPERATIVE_MATRIX_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_corner_sampled_image (pattern NV_CORNER_SAMPLED_IMAGE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_coverage_reduction_mode (pattern NV_COVERAGE_REDUCTION_MODE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_dedicated_allocation_image_aliasing (pattern NV_DEDICATED_ALLOCATION_IMAGE_ALIASING_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_device_diagnostics_config (pattern NV_DEVICE_DIAGNOSTICS_CONFIG_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_device_diagnostic_checkpoints (pattern NV_DEVICE_DIAGNOSTIC_CHECKPOINTS_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_device_generated_commands (pattern NV_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_external_memory_capabilities (pattern NV_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_external_memory (pattern NV_EXTERNAL_MEMORY_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_external_memory_win32 (pattern NV_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_fragment_shader_barycentric (pattern NV_FRAGMENT_SHADER_BARYCENTRIC_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_fragment_shading_rate_enums (pattern NV_FRAGMENT_SHADING_RATE_ENUMS_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_framebuffer_mixed_samples (pattern NV_FRAMEBUFFER_MIXED_SAMPLES_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_mesh_shader (pattern NV_MESH_SHADER_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_ray_tracing (pattern NV_RAY_TRACING_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_scissor_exclusive (pattern NV_SCISSOR_EXCLUSIVE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_shader_image_footprint (pattern NV_SHADER_IMAGE_FOOTPRINT_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_shader_sm_builtins (pattern NV_SHADER_SM_BUILTINS_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_shader_subgroup_partitioned (pattern NV_SHADER_SUBGROUP_PARTITIONED_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_shading_rate_image (pattern NV_SHADING_RATE_IMAGE_EXTENSION_NAME)
import Vulkan.Extensions.VK_NV_win32_keyed_mutex (pattern NV_WIN32_KEYED_MUTEX_EXTENSION_NAME)
import Vulkan.Extensions.VK_QCOM_render_pass_transform (pattern QCOM_RENDER_PASS_TRANSFORM_EXTENSION_NAME)
import Vulkan.Extensions.VK_QCOM_rotated_copy_commands (pattern QCOM_ROTATED_COPY_COMMANDS_EXTENSION_NAME)
import Vulkan.Extensions.VK_QNX_screen_surface (pattern QNX_SCREEN_SURFACE_EXTENSION_NAME)
import Vulkan.Extensions.VK_VALVE_mutable_descriptor_type (pattern VALVE_MUTABLE_DESCRIPTOR_TYPE_EXTENSION_NAME)
-- | The set of other extensions required to use this extension
extensionDependencies :: ("extensionName" ::: ByteString) -> [ByteString]
extensionDependencies = \case
  KHR_SWAPCHAIN_EXTENSION_NAME -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_DISPLAY_EXTENSION_NAME   -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_DISPLAY_SWAPCHAIN_EXTENSION_NAME ->
    [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  KHR_XLIB_SURFACE_EXTENSION_NAME              -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_XCB_SURFACE_EXTENSION_NAME               -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_WAYLAND_SURFACE_EXTENSION_NAME           -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_ANDROID_SURFACE_EXTENSION_NAME           -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_WIN32_SURFACE_EXTENSION_NAME             -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_DEBUG_MARKER_EXTENSION_NAME              -> [EXT_DEBUG_REPORT_EXTENSION_NAME]
  EXT_TRANSFORM_FEEDBACK_EXTENSION_NAME        -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  AMD_TEXTURE_GATHER_BIAS_LOD_EXTENSION_NAME   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  GGP_STREAM_DESCRIPTOR_SURFACE_EXTENSION_NAME -> [KHR_SURFACE_EXTENSION_NAME]
  NV_CORNER_SAMPLED_IMAGE_EXTENSION_NAME       -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_MULTIVIEW_EXTENSION_NAME                 -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_EXTERNAL_MEMORY_EXTENSION_NAME            -> [NV_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME]
  NV_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME ->
    [NV_EXTERNAL_MEMORY_EXTENSION_NAME, NV_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME]
  NV_WIN32_KEYED_MUTEX_EXTENSION_NAME ->
    [ NV_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME
    , NV_EXTERNAL_MEMORY_EXTENSION_NAME
    , NV_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    ]
  KHR_DEVICE_GROUP_EXTENSION_NAME                 -> [KHR_DEVICE_GROUP_CREATION_EXTENSION_NAME]
  NN_VI_SURFACE_EXTENSION_NAME                    -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_TEXTURE_COMPRESSION_ASTC_HDR_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_ASTC_DECODE_MODE_EXTENSION_NAME             -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_MEMORY_EXTENSION_NAME ->
    [KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_EXTERNAL_MEMORY_FD_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_WIN32_KEYED_MUTEX_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_WIN32_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME ->
    [KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_SEMAPHORE_WIN32_EXTENSION_NAME ->
    [ KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME
    , KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME ->
    [ KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME
    , KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_PUSH_DESCRIPTOR_EXTENSION_NAME     -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SHADER_FLOAT16_INT8_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_16BIT_STORAGE_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_STORAGE_BUFFER_STORAGE_CLASS_EXTENSION_NAME]
  KHR_INCREMENTAL_PRESENT_EXTENSION_NAME -> [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_DIRECT_MODE_DISPLAY_EXTENSION_NAME -> [KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_ACQUIRE_XLIB_DISPLAY_EXTENSION_NAME ->
    [EXT_DIRECT_MODE_DISPLAY_EXTENSION_NAME, KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_DISPLAY_SURFACE_COUNTER_EXTENSION_NAME -> [KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_DISPLAY_CONTROL_EXTENSION_NAME ->
    [ EXT_DISPLAY_SURFACE_COUNTER_EXTENSION_NAME
    , KHR_SWAPCHAIN_EXTENSION_NAME
    , KHR_DISPLAY_EXTENSION_NAME
    , KHR_SURFACE_EXTENSION_NAME
    ]
  GOOGLE_DISPLAY_TIMING_EXTENSION_NAME -> [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  NVX_MULTIVIEW_PER_VIEW_ATTRIBUTES_EXTENSION_NAME ->
    [KHR_MULTIVIEW_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_DISCARD_RECTANGLES_EXTENSION_NAME         -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_CONSERVATIVE_RASTERIZATION_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_SWAPCHAIN_COLOR_SPACE_EXTENSION_NAME      -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_HDR_METADATA_EXTENSION_NAME               -> [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  KHR_IMAGELESS_FRAMEBUFFER_EXTENSION_NAME -> [KHR_MAINTENANCE2_EXTENSION_NAME, KHR_IMAGE_FORMAT_LIST_EXTENSION_NAME]
  KHR_CREATE_RENDERPASS_2_EXTENSION_NAME ->
    [KHR_MULTIVIEW_EXTENSION_NAME, KHR_MAINTENANCE2_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SHARED_PRESENTABLE_IMAGE_EXTENSION_NAME ->
    [ KHR_SWAPCHAIN_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME
    , KHR_SURFACE_EXTENSION_NAME
    ]
  KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_FENCE_EXTENSION_NAME ->
    [KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_EXTERNAL_FENCE_WIN32_EXTENSION_NAME ->
    [ KHR_EXTERNAL_FENCE_EXTENSION_NAME
    , KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_EXTERNAL_FENCE_FD_EXTENSION_NAME ->
    [ KHR_EXTERNAL_FENCE_EXTENSION_NAME
    , KHR_EXTERNAL_FENCE_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_PERFORMANCE_QUERY_EXTENSION_NAME          -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_VARIABLE_POINTERS_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_STORAGE_BUFFER_STORAGE_CLASS_EXTENSION_NAME]
  KHR_GET_DISPLAY_PROPERTIES_2_EXTENSION_NAME -> [KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  MVK_IOS_SURFACE_EXTENSION_NAME              -> [KHR_SURFACE_EXTENSION_NAME]
  MVK_MACOS_SURFACE_EXTENSION_NAME            -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_EXTERNAL_MEMORY_DMA_BUF_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_FD_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  EXT_QUEUE_FAMILY_FOREIGN_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_DEDICATED_ALLOCATION_EXTENSION_NAME -> [KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME]
  ANDROID_EXTERNAL_MEMORY_ANDROID_HARDWARE_BUFFER_EXTENSION_NAME ->
    [ KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , EXT_QUEUE_FAMILY_FOREIGN_EXTENSION_NAME
    , KHR_DEDICATED_ALLOCATION_EXTENSION_NAME
    , KHR_MAINTENANCE1_EXTENSION_NAME
    , KHR_BIND_MEMORY_2_EXTENSION_NAME
    , KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    ]
  EXT_SAMPLER_FILTER_MINMAX_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_INLINE_UNIFORM_BLOCK_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_MAINTENANCE1_EXTENSION_NAME]
  EXT_SAMPLE_LOCATIONS_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME ->
    [ EXT_DESCRIPTOR_INDEXING_EXTENSION_NAME
    , KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME
    , KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_MAINTENANCE3_EXTENSION_NAME
    ]
  KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME ->
    [ KHR_SPIRV_1_4_EXTENSION_NAME
    , KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME
    , KHR_SHADER_FLOAT_CONTROLS_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , EXT_DESCRIPTOR_INDEXING_EXTENSION_NAME
    , KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME
    , KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME
    , KHR_MAINTENANCE3_EXTENSION_NAME
    ]
  KHR_RAY_QUERY_EXTENSION_NAME ->
    [ KHR_SPIRV_1_4_EXTENSION_NAME
    , KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME
    , KHR_SHADER_FLOAT_CONTROLS_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , EXT_DESCRIPTOR_INDEXING_EXTENSION_NAME
    , KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME
    , KHR_DEFERRED_HOST_OPERATIONS_EXTENSION_NAME
    , KHR_MAINTENANCE3_EXTENSION_NAME
    ]
  KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME ->
    [ KHR_MAINTENANCE1_EXTENSION_NAME
    , KHR_BIND_MEMORY_2_EXTENSION_NAME
    , KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  EXT_IMAGE_DRM_FORMAT_MODIFIER_EXTENSION_NAME ->
    [ KHR_BIND_MEMORY_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_IMAGE_FORMAT_LIST_EXTENSION_NAME
    , KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME
    , KHR_MAINTENANCE1_EXTENSION_NAME
    , KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME
    ]
  EXT_DESCRIPTOR_INDEXING_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_MAINTENANCE3_EXTENSION_NAME]
  KHR_PORTABILITY_SUBSET_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_SHADING_RATE_IMAGE_EXTENSION_NAME  -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_RAY_TRACING_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME]
  KHR_MAINTENANCE3_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_8BIT_STORAGE_EXTENSION_NAME ->
    [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME, KHR_STORAGE_BUFFER_STORAGE_CLASS_EXTENSION_NAME]
  EXT_EXTERNAL_MEMORY_HOST_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_SHADER_ATOMIC_INT64_EXTENSION_NAME      -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SHADER_CLOCK_EXTENSION_NAME             -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  AMD_SHADER_CORE_PROPERTIES_EXTENSION_NAME   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_VERTEX_ATTRIBUTE_DIVISOR_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  GGP_FRAME_TOKEN_EXTENSION_NAME ->
    [KHR_SWAPCHAIN_EXTENSION_NAME, GGP_STREAM_DESCRIPTOR_SURFACE_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  KHR_DRIVER_PROPERTIES_EXTENSION_NAME     -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SHADER_FLOAT_CONTROLS_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_DEPTH_STENCIL_RESOLVE_EXTENSION_NAME ->
    [ KHR_CREATE_RENDERPASS_2_EXTENSION_NAME
    , KHR_MULTIVIEW_EXTENSION_NAME
    , KHR_MAINTENANCE2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_SWAPCHAIN_MUTABLE_FORMAT_EXTENSION_NAME ->
    [ KHR_SWAPCHAIN_EXTENSION_NAME
    , KHR_MAINTENANCE2_EXTENSION_NAME
    , KHR_IMAGE_FORMAT_LIST_EXTENSION_NAME
    , KHR_SURFACE_EXTENSION_NAME
    ]
  NV_COMPUTE_SHADER_DERIVATIVES_EXTENSION_NAME    -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_MESH_SHADER_EXTENSION_NAME                   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_FRAGMENT_SHADER_BARYCENTRIC_EXTENSION_NAME   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_SHADER_IMAGE_FOOTPRINT_EXTENSION_NAME        -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_SCISSOR_EXCLUSIVE_EXTENSION_NAME             -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_DEVICE_DIAGNOSTIC_CHECKPOINTS_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_TIMELINE_SEMAPHORE_EXTENSION_NAME           -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  INTEL_SHADER_INTEGER_FUNCTIONS_2_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_PCI_BUS_INFO_EXTENSION_NAME                 -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  AMD_DISPLAY_NATIVE_HDR_EXTENSION_NAME ->
    [ KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME
    , KHR_SWAPCHAIN_EXTENSION_NAME
    , KHR_SURFACE_EXTENSION_NAME
    ]
  FUCHSIA_IMAGEPIPE_SURFACE_EXTENSION_NAME       -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_SHADER_TERMINATE_INVOCATION_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_METAL_SURFACE_EXTENSION_NAME               -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_FRAGMENT_DENSITY_MAP_EXTENSION_NAME        -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_SCALAR_BLOCK_LAYOUT_EXTENSION_NAME         -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_FRAGMENT_SHADING_RATE_EXTENSION_NAME ->
    [ KHR_CREATE_RENDERPASS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_MULTIVIEW_EXTENSION_NAME
    , KHR_MAINTENANCE2_EXTENSION_NAME
    ]
  AMD_SHADER_CORE_PROPERTIES_2_EXTENSION_NAME ->
    [AMD_SHADER_CORE_PROPERTIES_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_SHADER_IMAGE_ATOMIC_INT64_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SPIRV_1_4_EXTENSION_NAME ->
    [KHR_SHADER_FLOAT_CONTROLS_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_MEMORY_BUDGET_EXTENSION_NAME   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_MEMORY_PRIORITY_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SURFACE_PROTECTED_CAPABILITIES_EXTENSION_NAME ->
    [KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  NV_DEDICATED_ALLOCATION_IMAGE_ALIASING_EXTENSION_NAME ->
    [KHR_DEDICATED_ALLOCATION_EXTENSION_NAME, KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME]
  KHR_SEPARATE_DEPTH_STENCIL_LAYOUTS_EXTENSION_NAME ->
    [ KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_CREATE_RENDERPASS_2_EXTENSION_NAME
    , KHR_MULTIVIEW_EXTENSION_NAME
    , KHR_MAINTENANCE2_EXTENSION_NAME
    ]
  EXT_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME     -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_COOPERATIVE_MATRIX_EXTENSION_NAME         -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_COVERAGE_REDUCTION_MODE_EXTENSION_NAME    -> [NV_FRAMEBUFFER_MIXED_SAMPLES_EXTENSION_NAME]
  EXT_FRAGMENT_SHADER_INTERLOCK_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_YCBCR_IMAGE_ARRAYS_EXTENSION_NAME ->
    [ KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME
    , KHR_MAINTENANCE1_EXTENSION_NAME
    , KHR_BIND_MEMORY_2_EXTENSION_NAME
    , KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  KHR_UNIFORM_BUFFER_STANDARD_LAYOUT_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_PROVOKING_VERTEX_EXTENSION_NAME               -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_FULL_SCREEN_EXCLUSIVE_EXTENSION_NAME ->
    [ KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_SURFACE_EXTENSION_NAME
    , KHR_GET_SURFACE_CAPABILITIES_2_EXTENSION_NAME
    , KHR_SWAPCHAIN_EXTENSION_NAME
    ]
  EXT_HEADLESS_SURFACE_EXTENSION_NAME                   -> [KHR_SURFACE_EXTENSION_NAME]
  KHR_BUFFER_DEVICE_ADDRESS_EXTENSION_NAME              -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_LINE_RASTERIZATION_EXTENSION_NAME                 -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_SHADER_ATOMIC_FLOAT_EXTENSION_NAME                -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_HOST_QUERY_RESET_EXTENSION_NAME                   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_EXTENDED_DYNAMIC_STATE_EXTENSION_NAME             -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_PIPELINE_EXECUTABLE_PROPERTIES_EXTENSION_NAME     -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_SHADER_DEMOTE_TO_HELPER_INVOCATION_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_TEXEL_BUFFER_ALIGNMENT_EXTENSION_NAME             -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  QCOM_RENDER_PASS_TRANSFORM_EXTENSION_NAME             -> [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_DEVICE_MEMORY_REPORT_EXTENSION_NAME               -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_DEVICE_DIAGNOSTICS_CONFIG_EXTENSION_NAME           -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_SYNCHRONIZATION_2_EXTENSION_NAME                  -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_ZERO_INITIALIZE_WORKGROUP_MEMORY_EXTENSION_NAME   -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_FRAGMENT_SHADING_RATE_ENUMS_EXTENSION_NAME ->
    [ KHR_FRAGMENT_SHADING_RATE_EXTENSION_NAME
    , KHR_CREATE_RENDERPASS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    , KHR_MULTIVIEW_EXTENSION_NAME
    , KHR_MAINTENANCE2_EXTENSION_NAME
    ]
  EXT_YCBCR_2PLANE_444_FORMATS_EXTENSION_NAME ->
    [ KHR_SAMPLER_YCBCR_CONVERSION_EXTENSION_NAME
    , KHR_MAINTENANCE1_EXTENSION_NAME
    , KHR_BIND_MEMORY_2_EXTENSION_NAME
    , KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  EXT_FRAGMENT_DENSITY_MAP_2_EXTENSION_NAME ->
    [EXT_FRAGMENT_DENSITY_MAP_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  QCOM_ROTATED_COPY_COMMANDS_EXTENSION_NAME ->
    [KHR_SWAPCHAIN_EXTENSION_NAME, KHR_COPY_COMMANDS_2_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_IMAGE_ROBUSTNESS_EXTENSION_NAME                 -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  KHR_WORKGROUP_MEMORY_EXPLICIT_LAYOUT_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_4444_FORMATS_EXTENSION_NAME                     -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  NV_ACQUIRE_WINRT_DISPLAY_EXTENSION_NAME ->
    [EXT_DIRECT_MODE_DISPLAY_EXTENSION_NAME, KHR_DISPLAY_EXTENSION_NAME, KHR_SURFACE_EXTENSION_NAME]
  EXT_DIRECTFB_SURFACE_EXTENSION_NAME -> [KHR_SURFACE_EXTENSION_NAME]
  VALVE_MUTABLE_DESCRIPTOR_TYPE_EXTENSION_NAME ->
    [KHR_MAINTENANCE3_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_VERTEX_INPUT_DYNAMIC_STATE_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  FUCHSIA_EXTERNAL_MEMORY_EXTENSION_NAME ->
    [ KHR_EXTERNAL_MEMORY_CAPABILITIES_EXTENSION_NAME
    , KHR_EXTERNAL_MEMORY_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  FUCHSIA_EXTERNAL_SEMAPHORE_EXTENSION_NAME ->
    [ KHR_EXTERNAL_SEMAPHORE_CAPABILITIES_EXTENSION_NAME
    , KHR_EXTERNAL_SEMAPHORE_EXTENSION_NAME
    , KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME
    ]
  EXT_EXTENDED_DYNAMIC_STATE_2_EXTENSION_NAME -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  QNX_SCREEN_SURFACE_EXTENSION_NAME           -> [KHR_SURFACE_EXTENSION_NAME]
  EXT_COLOR_WRITE_ENABLE_EXTENSION_NAME       -> [KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  EXT_GLOBAL_PRIORITY_QUERY_EXTENSION_NAME ->
    [EXT_GLOBAL_PRIORITY_EXTENSION_NAME, KHR_GET_PHYSICAL_DEVICE_PROPERTIES_2_EXTENSION_NAME]
  _ -> []

-- | The minimum required API version to use this extension
extensionCoreRequirement :: ("extensionName" ::: ByteString) -> Word32
extensionCoreRequirement = \case
  KHR_ACCELERATION_STRUCTURE_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_RAY_TRACING_PIPELINE_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_RAY_QUERY_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  NV_SHADER_SM_BUILTINS_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_SHADER_SUBGROUP_EXTENDED_TYPES_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  NV_SHADER_SUBGROUP_PARTITIONED_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  EXT_SUBGROUP_SIZE_CONTROL_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_SPIRV_1_4_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_SURFACE_PROTECTED_CAPABILITIES_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  NV_DEVICE_GENERATED_COMMANDS_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  KHR_SHADER_SUBGROUP_UNIFORM_CONTROL_FLOW_EXTENSION_NAME -> MAKE_API_VERSION 1 1 0
  _                            -> API_VERSION_1_0

